import es
import time

# CONFIGS START
## How many times a user can double jump. Resets when he lands. (0 = None, -1 = infinite)
Max_Uses    = 1
## How hard to push the user
Push_Value  = 285
## Minimum time between each jump. (In seconds)
Intervals   = 0.25

# CONFIGS END

JumpsUsed           = {}
JumpsUsed['count']  = {}
JumpsUsed['time']   = {}

def load():
    es.msg("#multi","\x05[CDJ] #greenCheeTaHs Double Jump #defaulthas been loaded!")
    Set_Up_Public_Var()


def unload():
    es.msg("#multi","\x05[CDJ] #greenCheeTaHs Double Jump #defaulthas been unloaded!")


def es_map_start(ev):
    Set_Up_Public_Var()


def player_jump(ev):
    userid = ev['userid']
    JumpsUsed['count'][userid] = 0
    JumpsUsed['time'][userid] = 0


def Set_Up_Public_Var():
    PubVarVersion = "1.2CheeTaH-Public"
    PubVar = es.ServerVar("cdj_version",PubVarVersion,"Script Version")
    PubVar.set(PubVarVersion)
    PubVar.makepublic()


def client_keypress(ev):
    if not int(ev['status']):
        return
    if ev['keyname'] != 'jump':
        return
    DoTheJump(ev['userid'])


def sm2es_keypress(ev):
    if not int(ev['status']):
        return
    if ev['command'] != 'IN_JUMP':
        return
    DoTheJump(ev['userid'])


def DoTheJump(userid):
    newTime = time.time()
    
    if userid not in JumpsUsed['time'] or userid not in JumpsUsed['count']:
        ev = {}
        ev['userid'] = userid
        player_jump(ev)
        return
        
    if JumpsUsed['count'][userid] > Max_Uses and Max_Uses != -1:
        return
       
    timeBetween = newTime - JumpsUsed['time'][userid]
    if timeBetween > Intervals:
        if JumpsUsed['count'][userid] > 0:
            es.setplayerprop(ev['userid'],"CBasePlayer.localdata.m_vecBaseVelocity", "0,0,%s" %Push_Value)
        
        JumpsUsed['time'][userid] = newTime
        JumpsUsed['count'][userid] += 1